#include "bsp.hh"
#include "map.hh"

#include <cstdio>

using std::printf;

bsp::bsp(const XYZ &a, const XYZ &b, unsigned wc) : wallids(wc), p1(a), p2(b)
{
    for(unsigned c=0; c<wc; ++c)wallids[c] = c;
}

void bsp::SubSplit(autoptr<bsp> &dest,
                   const XYZ &a, const XYZ &b,
                   const MapWall *wallmap)
{
    dest = new bsp;
    dest->p1 = a;
    dest->p2 = b;
    
    for(unsigned a=0; a<wallids.size(); ++a)
        if(wallmap[wallids[a]].hits(dest->p1, dest->p2))
            dest->wallids.push_back(a);

    unsigned siz = dest->wallids.size();
    if(!siz || siz >= wallids.size())
    {
        dest = NULL;
    }
    else
    {
        dest->Split(wallmap);
    }
}

static unsigned indent;
void bsp::Split(const MapWall *wallmap)
{
    printf("%*s", indent, "");
    printf("Bsp at "); p1.print(); printf(" to "); p2.print(); printf("\n");
    ++indent;
    for(unsigned a=0; a<wallids.size(); ++a)
    {
        printf("%*s", indent, "");
        printf("Contains wall %u: ", wallids[a]); wallmap[wallids[a]].p1.print(); printf(" to ");
                                                  wallmap[wallids[a]].p2.print(); printf("\n");
    }

    /* Etsitn dividing point. Sen pitisi jakaa seint
     * kolmessa ulottuvuudessa kahteen yht suureen ryhmn.
     */
    if(wallids.size() == 2)
    {
        if(wallmap[wallids[0]].maxx() < wallmap[wallids[1]].minx())
            middle.x = (wallmap[wallids[0]].maxx() + wallmap[wallids[1]].minx()) / 2;
        else
            middle.x = (wallmap[wallids[0]].minx() + wallmap[wallids[1]].maxx()) / 2;
        if(wallmap[wallids[0]].maxy() < wallmap[wallids[1]].miny())
            middle.y = (wallmap[wallids[0]].maxy() + wallmap[wallids[1]].miny()) / 2;
        else
            middle.y = (wallmap[wallids[0]].miny() + wallmap[wallids[1]].maxy()) / 2;
        if(wallmap[wallids[0]].maxz() < wallmap[wallids[1]].minz())
            middle.z = (wallmap[wallids[0]].maxz() + wallmap[wallids[1]].minz()) / 2;
        else
            middle.z = (wallmap[wallids[0]].minz() + wallmap[wallids[1]].maxz()) / 2;
    }
    else
    {
        middle.Set(0,0,0);
        for(unsigned a=0; a<wallids.size(); ++a)
            middle += avg(wallmap[wallids[a]].p1, wallmap[wallids[a]].p2);
        middle /= wallids.size();
    }
    
    printf("%*s", indent, "");
    printf("Middle point: "); middle.print();
    unsigned hitcount=0;
    for(unsigned a=0; a<wallids.size(); ++a)
        if(wallmap[wallids[a]].hits(middle, middle))
        {
            if(!hitcount)printf(" (hits walls");else printf(",");
            printf(" %u", a);
            ++hitcount;
        }
    if(hitcount)printf(")");
    printf("\n");
    
    if(wallids.size() > 1)
    {
        SubSplit(nwu(), XYZ(p1.x,p1.y,p1.z),         XYZ(middle.x,middle.y,middle.z), wallmap);
        SubSplit(swu(), XYZ(p1.x,middle.y,p1.z),     XYZ(middle.x,p2.y,middle.z), wallmap);
        SubSplit(neu(), XYZ(middle.x,p1.y,p1.z),     XYZ(p2.x,middle.y,middle.z), wallmap);
        SubSplit(seu(), XYZ(middle.x,middle.y,p1.z), XYZ(p2.x,p2.y,middle.z), wallmap);
        SubSplit(nwd(), XYZ(p1.x,p1.y,middle.z),         XYZ(middle.x,middle.y,p2.z), wallmap);
        SubSplit(swd(), XYZ(p1.x,middle.y,middle.z),     XYZ(middle.x,p2.y,p2.z), wallmap);
        SubSplit(ned(), XYZ(middle.x,p1.y,middle.z),     XYZ(p2.x,middle.y,p2.z), wallmap);
        SubSplit(sed(), XYZ(middle.x,middle.y,middle.z), XYZ(p2.x,p2.y,p2.z), wallmap);
    }

    printf("%*s", --indent, "");
    printf("Bsp at "); p1.print(); printf(" to "); p2.print(); printf(" DONE\n");
}
